
#include "stdafx.h"
#include "util.h"
#include "ArcManACE.h"
#include "resource.h"

CArcManACE::CArcManACE()
{
	hDLL = LoadLibrary( "Unace.dll" );
	if( hDLL!=NULL )
	{
		OpenAce = (FUNC_OA)GetProcAddress( hDLL,"ACEOpenArchive" );
		CloseAce = (FUNC_CA)GetProcAddress( hDLL,"ACECloseArchive" );
		Header = (FUNC_HD)GetProcAddress( hDLL,"ACEReadHeader" );
		Process = (FUNC_PC)GetProcAddress( hDLL,"ACEProcessFile" );
		SetPassword = (FUNC_PW)GetProcAddress( hDLL,"ACESetPassword" );
		if( OpenAce==NULL || CloseAce==NULL || Header==NULL || Process==NULL || SetPassword==NULL )
		{
			FreeLibrary(hDLL);
			hDLL=NULL;
		}
	}
}

CArcManACE::~CArcManACE()
{
	if( hDLL!=NULL )
		FreeLibrary(hDLL);
}

void CArcManACE::VersionString( CKString& VerStr )
{
	VerStr = "Unace.dll    ";
	VerStr += (hDLL!=NULL) ? "Found":"Not Found";
}

bool CArcManACE::CanMelt( const char* fname )
{
	if( hDLL==NULL )return false;

	ACEOpenArchiveData Data;
	memset( &Data,0,sizeof(Data) );
	Data.ArcName = new char[strlen(fname)+1];
	strcpy( Data.ArcName,fname );
	Data.OpenMode = ACEOPEN_LIST;
	HANDLE h = OpenAce( &Data );
	delete [] Data.ArcName;
	CloseAce( h );
	return (Data.OpenResult==0);
}

static BOOL CALLBACK PwProc( HWND dlg,UINT msg,WPARAM wp,LPARAM lp )
{
	char* p = (char*)GetWindowLong( dlg,GWL_USERDATA );

	switch( msg )
	{
	case WM_INITDIALOG:
		{
			p = (char*)lp;
			SetWindowLong( dlg,GWL_USERDATA,lp );
			SendDlgItemMessage( dlg,IDC_FILENAME,WM_SETTEXT,0,(LPARAM)p );
			SetFocus( GetDlgItem(dlg,IDC_EDIT) );
			return FALSE;
		}
		break;
	case WM_SYSCOMMAND:
		switch( wp )
		{
		case SC_CLOSE:
		case SC_DEFAULT:
			SendDlgItemMessage( dlg,IDC_EDIT,WM_GETTEXT,60,(LPARAM)p );
			EndDialog(dlg,ID_APPLY_ALL);
			break;
		default:
			return FALSE;
		}
		break;
	case WM_COMMAND:
		{
			switch( LOWORD(wp) )
			{
			case ID_APPLY:
				SendDlgItemMessage( dlg,IDC_EDIT,WM_GETTEXT,60,(LPARAM)p );
				EndDialog(dlg,ID_APPLY);
				break;
			case ID_APPLY_ALL:
				SendDlgItemMessage( dlg,IDC_EDIT,WM_GETTEXT,60,(LPARAM)p );
				EndDialog(dlg,ID_APPLY_ALL);
				break;
			}
		}
		break;
	default:
		return FALSE;
	}
	return TRUE;
}
 
static BOOL CALLBACK DlgFunc( HWND dlg, UINT msg, WPARAM wp, LPARAM lp )
{
    return FALSE;
}

bool CArcManACE::Melt( CKString& File,CKString* pPath,bool bMDir,bool bNoDDir )
{
	if( hDLL==NULL )return false;

	char *dest = NULL;
	HANDLE h;
	ACEOpenArchiveData Data;memset( &Data,0,sizeof(Data) );
	ACEHeaderData Head;		memset( &Head,0,sizeof(Head) );
	Data.ArcName = new char[File.Length()+1];
	File.Buf( Data.ArcName );

	if( bMDir )
	{
		// tH_쐬
		CKString Tmp,MadeDirName;
		File.SplitPath( Tmp,MadeDirName,Tmp );
		MadeDirName += "\\";
		MadeDirName.ToLowerCase();

		// dtH_ɂȂ\
		bool b=false;
		if( bNoDDir )
		{
			Data.OpenMode = ACEOPEN_LIST;
			h = OpenAce( &Data );
			if( Data.OpenResult!=0 )
			{
				delete [] Data.ArcName;
				CloseAce( h );
				return false;
			}
			b=true;
			while( 0==Header( h,&Head ) )
			{
				_mbslwr((unsigned char*)Head.FileName);
				if( Head.FileName!=strstr( Head.FileName,MadeDirName ) )
				{
					b=false;
					break;
				}
				Process( h,ACECMD_SKIP,NULL );
			}
			CloseAce( h );
		}

		// dtH_
		if( b )
		{
			dest = new char[pPath->Length()+1];
			pPath->Buf( dest );
		}
		// 쐬tH_ۑ
		*pPath += MadeDirName;
	}

	if( dest==NULL )
	{
		dest = new char[pPath->Length()+1];
		pPath->Buf( dest );
	}

	Data.OpenMode = ACEOPEN_EXTRACT;
	h = OpenAce( &Data );
	if( Data.OpenResult!=0 )
	{
		CloseAce( h );
		delete [] Data.ArcName;
		delete [] dest;
		return false;
	}

	CreateDir( dest );

	int param=1;
	HWND hDlg = CreateDialogParam( GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_PROCESSARC),NULL,DlgFunc,(LPARAM)&param );
	SendMessage( hDlg,WM_SETTEXT,0,(LPARAM)"Expanding ACE Archive..." );
	CKString Name;	File.GetFileName(Name);
	SendDlgItemMessage( hDlg,IDC_FROM,WM_SETTEXT,0,(LPARAM)(const char*)Name );
	SendDlgItemMessage( hDlg,IDCANCEL,WM_SETTEXT,0,(LPARAM)"" );
	ShowWindow( hDlg,SW_SHOW );
	UpdateWindow( hDlg );

	char password[260]="";
	while( 0==Header( h,&Head ) )
	{
		if( param==0 )
			break;
		SendDlgItemMessage( hDlg,IDC_TO,WM_SETTEXT,0,(LPARAM)Head.FileName );

		if( (Head.Flags&(1<<14)) && password[0]=='\0' )
		{
			strcpy( password,Head.FileName );
			int ans=DialogBoxParam( GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_ACE_PW),
											NULL,PwProc,(LPARAM)password );
			SetPassword( h,password );
			if( ans==ID_APPLY )password[0]='\0';
		}
		Process( h,ACECMD_EXTRACT,dest );
	}
	delete [] dest;
	delete [] Data.ArcName;

	DestroyWindow( hDlg );

	CloseAce( h );
	return true;
}
