
//////////////////////////////////////////////////////////////////////////////////////
// ArcManDLL.h: CArcManDLL NX̃C^[tFCX
//				A[JCoΉckk̃NXőSĈƂdiHjȃNX
//////////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ARCMANDLL_H__C4448BE0_75EA_11D3_8D95_D2AC66FFBD3A__INCLUDED_)
#define AFX_ARCMANDLL_H__C4448BE0_75EA_11D3_8D95_D2AC66FFBD3A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ArcMan.h"

///////////////////////////////////////////////////////////////////////////////

typedef WORD (WINAPI * DLL_VERSION)(void);
typedef int (WINAPI * DLL_CMD)(const HWND,const char*,char*,const DWORD);
typedef BOOL (WINAPI * DLL_CHECK)(const char*,const int);

typedef	HGLOBAL	HARC;
typedef struct
{
	DWORD 	dwOriginalSize;
	DWORD 	dwCompressedSize;
	DWORD	dwCRC;
	UINT	uFlag;
	UINT	uOSType;
	WORD	wRatio;
	WORD	wDate;
	WORD 	wTime;
	char	szFileName[512 + 1];
	char	dummy1[3];
	char	szAttribute[8];
	char	szMode[8];
}	INDIVIDUALINFO;

typedef HARC (WINAPI * DLL_OPENARC)(const HWND,LPCSTR,const DWORD);
typedef int (WINAPI * DLL_CLOSEARC)(HARC);
typedef int (WINAPI * DLL_FINDFIRST)(HARC,LPCSTR,INDIVIDUALINFO FAR *);
typedef int (WINAPI * DLL_FINDNEXT)(HARC,INDIVIDUALINFO FAR *);
typedef int (WINAPI * DLL_GETNAME)(HARC,LPSTR,const int);

//////////////////////////////////////////////////////////////////////////////

class CArcManDLL : public CArcMan
{
public:
	CArcManDLL();
	virtual ~CArcManDLL();
	void VersionString( CKString& VerStr );

	bool LoadFromNST( const char* filename );
	void Init(LPCSTR Dll,LPCTSTR VerF,LPCTSTR CmdF,LPCTSTR ChkF);
	void SetSFXCmd( const char* pCmd ){m_SfxCmd = pCmd;};
	void SetMeltCmd( const char* pCmd ){m_MeltCmd = pCmd;};
	void AddCompressCmd( const char* pType,const char* pExt,const char* pCmd );

	bool CanMelt( const char* fname );
	bool CanCompress( CKString& Type );
	bool CanSFX();

	bool Melt( CKString& File,CKString* pPath,bool bMDir,bool bNoDDir );
	bool Compress( CKString& Type,CFileList& Files,CKString& Path,CKString* pResult=NULL );
	bool SFX( CKString& Type,CFileList& Files,CKString& Path );

protected:
	virtual bool ExecCommand( const char* cmd , const char* current = NULL );

	bool m_bAble;

	CKString m_ModuleName;
	CKString m_CmpCmds[3];
	CKString m_Exts[3];
	CKString m_MeltCmd;
	CKString m_SfxCmd;

private:
	HINSTANCE hDLL;
	DLL_VERSION VerFunc;
	DLL_CMD CmdFunc;
	DLL_CHECK ChkFunc;
};

#endif // !defined(AFX_ARCMANDLL_H__C4448BE0_75EA_11D3_8D95_D2AC66FFBD3A__INCLUDED_)
