
#include "stdafx.h"
#include "ArcManMS2.h"
#include "util.h"
#include "Table.h"
#include "Resource.h"

BOOL CALLBACK CArcManMS2::DlgFunc( HWND dlg, UINT msg, WPARAM wp, LPARAM lp )
{
	if( msg==WM_INITDIALOG )
	{
		CArcManMS2* ms = (CArcManMS2*)lp;
		ms->m_hDlg = dlg;
		SetWindowLong( dlg,GWL_USERDATA,lp );
		UpdateWindow(dlg);
		SetFocus((HWND)wp);
		SendDlgItemMessage( dlg,IDC_GRAPH,PBM_SETRANGE,0,MAKELPARAM(0,128) );
		SetTimer( dlg,178116,200,NULL );
		return TRUE;
	}
	else if( msg==WM_TIMER )
	{
		CArcManMS2* ms = (CArcManMS2*)GetWindowLong( dlg , GWL_USERDATA );
		SendDlgItemMessage( dlg,IDC_GRAPH,PBM_SETPOS,ms->m_DlgParam,0 );
	}
	else if( msg==WM_SYSCOMMAND && (wp==SC_CLOSE || wp==SC_DEFAULT) )
	{
		SendMessage(dlg,WM_COMMAND,IDCANCEL,0);
		return TRUE;
	}
	else if( msg==WM_COMMAND && LOWORD(wp)==IDCANCEL )
	{
		CArcManMS2* ms = (CArcManMS2*)GetWindowLong( dlg , GWL_USERDATA );
		ms->m_hDlg=NULL;
		KillTimer( dlg,178116 );
		EndDialog( dlg,IDCANCEL );
		return TRUE;
	}
    return FALSE;
}

DWORD WINAPI CArcManMS2::ThreadFunc(void * p)
{
	CArcManMS2* ms = (CArcManMS2*)p;
	if( -1==DialogBoxParam(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_PROCESSARC),NULL,DlgFunc,(LPARAM)p) )
		ms->m_hDlg = (HWND)-1;
	ExitThread(0);
	return TRUE;
}

void CArcManMS2::VersionString( CKString& VerStr )
{
	OSVERSIONINFO os;
	os.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&os);
	switch(os.dwPlatformId)
	{
	case VER_PLATFORM_WIN32s:		VerStr="Windows      3.1";	break;
	case VER_PLATFORM_WIN32_WINDOWS:
		if( os.dwMinorVersion==0 )	VerStr="Windows      95";
		else						VerStr="Windows      98";
		break;
	case VER_PLATFORM_WIN32_NT:
		{
			char nt[255];
			sprintf(nt,"Windows NT   %d.%d",os.dwMajorVersion,os.dwMinorVersion);
			VerStr = nt;
		}
		break;
	}
}

bool CArcManMS2::CanMelt( const char* fname )
{
	HANDLE hFile = CreateFile( fname,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL
		                          ,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if( hFile==INVALID_HANDLE_VALUE  )
		return false;

	unsigned char p[14];
	unsigned char head[10]={ 0x53,0x5A,0x44,0x44,0x88,0xF0,0x27,0x33,0x41 };//="SZDD'3A";
	DWORD d;
	ReadFile( hFile,p,14,&d,NULL );
	bool ans = ( d==14 && 0==memcmp(p,head,9) );
	CloseHandle( hFile );
	return ans;

/*
	FILE* in = fopen( fname,"rb" );
	if( in==NULL )	return false;
	bool ans = ReadHeader( in );
	fclose(in);
	return ans;
*/
}

bool CArcManMS2::Melt( CKString& File,CKString* pPath,bool bMDir,bool bNoDDir )
{
	CKString Dir,Name,Ext,Tmp;
	OFSTRUCT of;
	of.cBytes = sizeof(of);
	if( bMDir )
		*pPath+="noah_lz\\";

	m_Ext3='\0';
	m_Length=0;

	FILE* in = fopen( File,"rb" );
	if( in==NULL )	return false;

	if( !ReadHeader( in ) )
	{
		fclose(in);
		return false;
	}

	char ex[2]={m_Ext3,'\0'};

	File.GetFileName( Name );
	char *name = new char[Name.Length()+1];
	Name.Buf( name );

	char* x = CharPrev( name,&name[strlen(name)] );
	if( *x=='_' )*x = '\0';

	CKString MotName=*pPath;
	CreateDir( MotName );
	MotName += name;delete [] name;
	MotName += ex;
	MotName.ToLowerCase();
	MotName.SplitPath( Dir,Name,Ext );

	// gqɕ⊮
		 if( Ext=="ex" )MotName+="e";
	else if( Ext=="co" )MotName+="m";
	else if( Ext=="sc" )MotName+="r";

	else if( Ext=="dl" )MotName+="l";
	else if( Ext=="oc" )MotName+="x";
	else if( Ext=="dr" )MotName+="v";
	else if( Ext=="38" )MotName+="6";
	else if( Ext=="sy" )MotName+="s";
	else if( Ext=="cp" )MotName+="l";
	else if( Ext=="li" )MotName+="b";
	else if( Ext=="tt" )MotName+="f";

	else if( Ext=="ch" )MotName+="m";
	else if( Ext=="hl" )MotName+="p";
	else if( Ext=="cn" )MotName+="t";
	else if( Ext=="da" )MotName+="t";

	else if( Ext=="tx" )MotName+="t";
	else if( Ext=="wr" )MotName+="i";
	else if( Ext=="wa" )MotName+="v";
	else if( Ext=="mi" )MotName+="d";
	else if( Ext=="bm" )MotName+="p";
	else if( Ext=="rl" )MotName+="e";

///܂Ńt@C////////////////////////////////

/*overwrite*/if( PathFileExists(MotName) )
/*overwrite*/{
/*overwrite*/	char msg[4000];
/*overwrite*/	sprintf( msg,"\"%s\" already exists.\nDo you want to OVERWRITE?",(const char*)MotName );
/*overwrite*/	if( IDNO==MessageBox(NULL,msg,"Noah",MB_YESNO|MB_ICONQUESTION|MB_TASKMODAL) )
/*overwrite*/	{
/*overwrite*/		fclose(in);
/*overwrite*/		return false;
/*overwrite*/	}
/*overwrite*/}

	FILE* out = fopen( MotName,"wb" );
	if( out==NULL )
	{
		fclose(in);
		return false;
	}

/*dialog*/m_hDlg=NULL;m_DlgParam=0;DWORD id;
/*dialog*/HANDLE thd = CreateThread( NULL,0,ThreadFunc,this,0,&id);while( m_hDlg==NULL );
/*dialog*/SendMessage( m_hDlg,WM_SETTEXT,0,(LPARAM)"Expanding MS-Compress..." );
/*dialog*/File.GetFileName(Name);
/*dialog*/SendDlgItemMessage( m_hDlg,IDC_FROM,WM_SETTEXT,0,(LPARAM)(const char*)Name );
/*dialog*/MotName.GetFileName(Name);
/*dialog*/SendDlgItemMessage( m_hDlg,IDC_TO,WM_SETTEXT,0,(LPARAM)(const char*)Name );

	MeltMain( in,out );

	fclose( in );
	fclose( out );

/*dialog*/if( m_hDlg!=NULL )EndDialog( m_hDlg,IDCANCEL );
/*dialog*/else	DeleteFile( MotName );

	return true;
}

bool CArcManMS2::Compress( CKString& Type,CFileList& Files,CKString& Path,CKString* pResult )
{
	// TypeɉĂׂ
	lenLV = 15,stkLV = 30;

	m_Ext3='\0';
	m_Length=0;

	for( int i=0; i!=Files.GetLength(); i++ )
	{
		FILE* in = fopen( Files.GetAt(i),"rb" );
		if( in==NULL )	continue;

		CKString Name;
		Files.GetAt(i).GetFileName( Name );

		char *name = new char[Name.Length()+1];
		Name.Buf( name );
		char* x = CharPrev( name,&name[strlen(name)] );
		if( !IsDBCSLeadByte(*x) )
			m_Ext3=*x;
		*x = '_';	*(x+1) = '\0';

		CKString ToName = Path;
		ToName += name;delete [] name;
		if( pResult!=NULL )*pResult = ToName;

/*overwrite*/if( PathFileExists(ToName) )
/*overwrite*/{
/*overwrite*/	char msg[4000];
/*overwrite*/	sprintf( msg,"\"%s\" already exists.\nDo you want to OVERWRITE?",(const char*)ToName );
/*overwrite*/	if( IDNO==MessageBox(NULL,msg,"Noah",MB_YESNO|MB_ICONQUESTION|MB_TASKMODAL) )
/*overwrite*/	{
/*overwrite*/		fclose(in);
/*overwrite*/		continue;
/*overwrite*/	}
/*overwrite*/}

		FILE* out = fopen( ToName,"wb" );
		if( out==NULL )
		{
			fclose(in);
			continue;
		}

		fseek( in,0,SEEK_END );
		m_Length = ftell(in);
		fseek( in,0,SEEK_SET );

/*dialog*/m_hDlg=NULL;m_DlgParam=0;DWORD id;
/*dialog*/HANDLE thd = CreateThread( NULL,0,ThreadFunc,this,0,&id);while( m_hDlg==NULL );
/*dialog*/SendMessage( m_hDlg,WM_SETTEXT,0,(LPARAM)"Compressing MS-Compress..." );
/*dialog*/Files.GetAt(i).GetFileName(Name);
/*dialog*/SendDlgItemMessage( m_hDlg,IDC_FROM,WM_SETTEXT,0,(LPARAM)(const char*)Name );
/*dialog*/ToName.GetFileName(Name);
/*dialog*/SendDlgItemMessage( m_hDlg,IDC_TO,WM_SETTEXT,0,(LPARAM)(const char*)Name );

		WriteHeader( out );
		CompressMain( in,out );

		fclose( in );
		fclose( out );

/*dialog*/if( m_hDlg!=NULL )EndDialog( m_hDlg,IDCANCEL );
/*dialog*/else	DeleteFile( ToName );
	}
	return true;
}

#define BUFSIZE (65536)

bool CArcManMS2::ReadHeader( FILE* fp )
{
	unsigned char p[14];
	unsigned char header[]="SZDD'3A";

	if( fread( p,1,14,fp )<14 || 0!=memcmp(p,header,9) )return false;
	m_Ext3 = p[9];
	m_Length = p[10] + (p[11]<<8) + (p[12]<<16) + (p[13]<<24);
	return true;
}

void CArcManMS2::MeltMain( FILE* in,FILE* out )
{
	// fwrite() 炷߂64KB̃obt@O
	unsigned char outbuf[BUFSIZE];
	unsigned long op=0;

	// fread() 炷߂64KB̃obt@O
	unsigned char inbuf[BUFSIZE];
	unsigned long ip=0;
	unsigned long inend;
	inend=fread( inbuf,1,BUFSIZE,in );

	// 
	unsigned char table[4096];
	memset( table,' ',sizeof(table) );
	unsigned long pos=0;

	// o̓oCg
	unsigned long total=0;

	// e|ϐ
	unsigned char d[2];
	unsigned char flag;

	while( total<m_Length )
	{
/*dialog*/if( m_hDlg==NULL )break;
/*dialog*/m_DlgParam=(total<<7)/m_Length;

		flag = inbuf[ip];
		if( ip==inend )break;
		ip++;if( ip==BUFSIZE )inend=fread( inbuf,1,BUFSIZE,in ),ip=0;

		for( int t=0; t!=8&&total<m_Length; t++ )
		{
			if( flag & (1<<t) )
			{
				d[0] = inbuf[ip];
				if( ip==inend )break;
				ip++;if( ip==BUFSIZE )inend=fread( inbuf,1,BUFSIZE,in ),ip=0;

				outbuf[op] = table[pos] = d[0];
				op++;if( op==BUFSIZE )fwrite( outbuf,1,BUFSIZE,out ),op=0;

				total++;
				pos++;if( pos==4096 )pos=0;
			}
			else
			{
				d[0] = inbuf[ip];
				if( ip==inend )break;
				ip++;if( ip==BUFSIZE )inend=fread( inbuf,1,BUFSIZE,in ),ip=0;
				d[1] = inbuf[ip];
				if( ip==inend )break;
				ip++;if( ip==BUFSIZE )inend=fread( inbuf,1,BUFSIZE,in ),ip=0;

				unsigned long off=((d[0]|((d[1]&0xf0)<<4))+0x10)&0x0fff , len=(d[1]&0x0f)+0x3;
				unsigned long end = (pos+len)&0x0fff;

				while( pos!=end && total<m_Length )
				{
					outbuf[op] = table[pos] = table[off];
					op++;if( op==BUFSIZE )fwrite( outbuf,1,BUFSIZE,out ),op=0;

					total++;
					pos++;if( pos==4096 )pos=0;
					off++;if( off==4096 )off=0;
				}
			}
		}
	}

	fwrite( outbuf,1,op,out );
}

bool CArcManMS2::WriteHeader( FILE* fp )
{
	fwrite( "SZDD'3A",1,9,fp );
	fwrite( &m_Ext3,1,1,fp );
	unsigned char a[4] = { (unsigned char)(m_Length&0xff) , (unsigned char)((m_Length>>8)&0xff) ,
						(unsigned char)((m_Length>>16)&0xff), (unsigned char)((m_Length>>24)&0xff) };
	fwrite( a,1,4,fp );
	return true;
}

void CArcManMS2::CompressMain( FILE* in,FILE* out )
{
	// fwrite() 炷߂64KB̃obt@O
	unsigned char outbuf[BUFSIZE];
	long op=0;

	// fread() 炷߂64KB̃obt@O
	unsigned char inbuf[BUFSIZE];
	long ip=0;
	long inend;
	inend=fread( inbuf,1,BUFSIZE,in );

	// 
	CTable tbl( lenLV,stkLV );// kx( lengthLV (3<LV<18) , EstockLV(ɂƂ-1)
								// 10,30 ӂ肪ÓȐH

	// o̓oCg
	unsigned long total=0;

	// ubN
	unsigned char block[17]={0};
	long bp=1;
	long bc=0;

	while( ip!=inend && ip!=17 )
		tbl.AddData( inbuf[ip] ),ip++;

	while( total<m_Length )
	{
/*dialog*/if( m_hDlg==NULL )break;
/*dialog*/m_DlgParam=(total<<7)/m_Length;

		long adrs=0,len=3;
		bool bCmprs = tbl.Find(&adrs,&len);

		if( bCmprs )
		{
			// k̏ꍇ
			block[bp]=(unsigned char)((adrs-16)&0xff);
			block[bp+1]=(unsigned char)((((adrs-16)&0xf00)>>4)|(len-3));
			bp+=2;

			for( long t=0; t!=len; t++ )
			{
				if( ip==BUFSIZE )inend=fread( inbuf,1,BUFSIZE,in ),ip=0;
				if( ip!=inend )tbl.AddData( inbuf[ip] ),ip++;
			}

			tbl.Move( len );
			total+=len;
		}
		else
		{
			//񈳏k̏ꍇ
			block[0] |= (1<<bc);
			block[bp]=tbl.Get();
			bp++;

			if( ip==BUFSIZE )inend=fread( inbuf,1,BUFSIZE,in ),ip=0;
			if( ip!=inend )tbl.AddData( inbuf[ip] ),ip++;

			tbl.Move( 1 );
			total++;
		}

		bc++;
		if( bc==8 )
		{
			if( op<BUFSIZE-bp )
				memcpy( outbuf+op,block,bp ),op+=bp;
			else
			{
				memcpy( outbuf+op,block,BUFSIZE-op );
				fwrite( outbuf,1,BUFSIZE,out );
				memcpy( outbuf,block+BUFSIZE-op,bp+op-BUFSIZE ),op=bp+op-BUFSIZE;
			}
			block[0]=0;bc=0;bp=1;
		}
	}

	// Ō̃ubÑf[^Wɑ
	while( bc!=8 )block[0]|=(1<<bc),block[bp]=0,bp++,bc++;
	if( op<BUFSIZE-bp )
		memcpy( outbuf+op,block,bp ),op+=bp;
	else
	{
		memcpy( outbuf+op,block,BUFSIZE-op );
		fwrite( outbuf,1,BUFSIZE,out );
		memcpy( outbuf,block+BUFSIZE-op,bp+op-BUFSIZE ),op=bp+op-BUFSIZE;
	}

	fwrite( outbuf,1,op,out );
}
