
#include "stdafx.h"
#include "FileList.h"
#include "util.h"

CFileList::CFileList()
{
	m_Len=0;
	m_AllocLen=0;
	m_pList=NULL;
	m_pInfo=NULL;
}

CFileList::~CFileList()
{
	ReleaseAll();
}

void CFileList::ReleaseAll()
{
	if( m_pList!=NULL )
		delete [] m_pList;
	m_pList=NULL;
	if( m_pInfo!=NULL )
		delete [] m_pInfo;
	m_pInfo=NULL;
}

void CFileList::ReAlloc()
{
	DWORD* d = new DWORD[m_AllocLen<<1];
	memcpy( d,m_pInfo,m_Len );
	CKString* p = new CKString[m_AllocLen<<1];
	for( int i=0; i!=m_Len; i++ )
		p[i] = m_pList[i];
	ReleaseAll();
	m_AllocLen<<=1;
	m_pInfo = d;
	m_pList = p;
}

void CFileList::Create( char* pCmd )
{
	ReleaseAll();

	int argc;	char** argv;
	MakeArg(&argc,&argv,pCmd);

	for( int i=0; i!=argc; i++ )
	{
		if( (argv[i])[0]!='-' && (argv[i])[0]!='/' )
			Add(argv[i]);
	}

	FreeArg(argc,&argv);
}

void CFileList::Create( HDROP hDrop )
{
	ReleaseAll();

	char file[MAX_PATH];
	int s = DragQueryFile( hDrop,0xFFFFFFFF,NULL,0 );
	for(int i=0;i<s;i++)
	{
		DragQueryFile( hDrop,i,file,MAX_PATH );
		Add(file);
	}
	DragFinish(hDrop);
}

void CFileList::Add( char* pFileName )
{
	if( m_pList==NULL )
	{
		m_Len=0;
		m_AllocLen=20;
		m_pList = new CKString[m_AllocLen];
		m_pInfo = new DWORD[m_AllocLen];
	}

	if( m_Len>=m_AllocLen )
		ReAlloc();

	WIN32_FIND_DATA Dt;
	FindClose( FindFirstFile(pFileName,&Dt) );
	CKString Dir,Name,Ext;
	m_pList[m_Len] = pFileName;
	m_pList[m_Len].SplitPath(Dir,Name,Ext);
	m_pList[m_Len] = Dir;
	m_pList[m_Len] += "\\";
	m_pList[m_Len] += Dt.cFileName;
	m_Len++;
}

